<?php
/*
Plugin Name: Chatlive
Plugin URI: http://www.marreroclaudio.com.ar
Description: Chat para soporte al cliente, multi session.
Version: 1.6
Author: Claudio Adrian Marrero
Author URI: http://www.marreroclaudio.com.ar
License: GPL2
*/
/*  Copyright 2012  Claudio Adrian Marrero  (email : cmarrero01@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
//Definimos pats para realizar includs
define('chat_path', plugins_url().'/chatlive');
define('chat_inc', plugins_url().'/chatlive/includes');
define('chat_include',ABSPATH.'/wp-content/plugins/chatlive/includes');
define('chat_lib',ABSPATH.'/wp-content/plugins/chatlive/lib');

//Estilos para cargar al admin del chat.
function chat_js_and_styles(){	?>
    <link href="<?php echo chat_path; ?>/css/style.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/jquery.scrollTo-min.js"></script>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/swfobject.js"></script>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/functions_admin.js"></script>
    <?php
}
add_action('admin_head', 'chat_js_and_styles');
//Admin hook
function chat_wp_head(){
	?>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/jquery-1.7.2.min.js"></script>
    <script>
	$(function(){
		$('body').prepend('<iframe frameborder="0" hspace="0" vspace="0" scrolling="no" allowtransparency="true" src="<?=chat_path;?>/chat_widget.php" id="chat_widget"></iframe>');
	});
	</script>
    <?php
}
add_action('wp_head', 'chat_wp_head');
/*
Menu Sistema
*/
function chat_menu_set(){
	//Productos
	$chat = add_menu_page('chatlive', 'Chat Live', 'edit_pages','chat-live','chat_admin');
}
add_action('admin_menu','chat_menu_set');

//Inicializacion del chat para el usuario
function chat_init($options=array()){
	global $wpdb;
	$default['is_widget'] = '';
	$settings = getMerge($default, $options);
	
	$chat_options = chat_options();
	$chat_options = $chat_options[0];
	
	//header del chat, solo para la vista del usuario cliente
	chat_header('is_widget='.$settings->is_widget);
	
	if(!empty($settings->is_widget)){
		chat_widget_header($chat_options->is_online);
	}
?>
    <div id="chat_windows" class="chat_ContentWindows">
        <? //Le pdeimos al usuario el email antes de poder chatear
		chat_email(); 
		?>
    </div>
<?php
	if(!empty($settings->is_widget)){
		chat_widget_footer();
	}
	//Footer del chat, solo para la vista del usuario cliente
	chat_footer();
}

function chat_widget_header($is_online=false){
		if($is_online){
			$flag = 1;
			$message = '<span>Preguntas?,</span> chatea con nosotros';
		}else{
			$flag = 0;
			$message = '<span>Lo sentimos?,</span> no estamos online';
		}
	?>
    <div class="showChat" id="showChat" flag="<?=$flag;?>"><?=$message;?></div>
    <div class="close_button" id="close_widget">&nbsp;</div>
    <div id="chat_ContentWidget">
    <?php
}

function chat_widget_footer(){
	?>
    </div>
    <?php
}

function chat_js_style_widget(){
	?>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/functions_widget.js"></script>
    <link rel="stylesheet" type="text/css" href="<?php echo chat_path; ?>/css/style_widget.css">
    <!--[if IE 7]>
    <link rel="stylesheet" type="text/css" href="<?php echo chat_path; ?>/css/style_widget-ie7-ie8.css">
    <![endif]-->
    <!--[if IE 8]>
    <link rel="stylesheet" type="text/css" href="<?php echo chat_path; ?>/css/style_widget-ie7-ie8.css">
    <![endif]-->
    <!--[if IE 9]>
    <link rel="stylesheet" type="text/css" href="<?php echo chat_path; ?>/css/style_widget-ie9.css">
    <![endif]-->
    <?php
}
//header del chat, solo para uso del usuario cliente
function chat_header($options=array()){
	global $wpdb;
	$default['is_widget'] = '';
	$settings = getMerge($default, $options);
	?>
    <html>
    <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title><?php bloginfo('name'); ?></title>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/jquery-1.7.2.min.js"></script>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/swfobject.js"></script>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/jquery.scrollTo-min.js"></script>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/jquery.validate.min.js"></script>
    <script type="text/javascript" src="<?php echo chat_path; ?>/js/functions.js"></script>
    <link href='http://fonts.googleapis.com/css?family=Quattrocento+Sans:400,400italic,700,700italic' rel='stylesheet' type='text/css'>
    <link rel="stylesheet" type="text/css" href="<?php echo chat_path; ?>/css/style.css">
    <?php if(!empty($settings->is_widget)){
		chat_js_style_widget();
	}?>
    </head>
    <body>
    <div id="ajax-response" url="<?=chat_path; ?>"></div>
    <?php
}
//Footer, ste solo lo ve el usuario cliente
function chat_footer(){
	?>
    </body>
    </html>
    <?php
}

//Le pedimos el email al cliente, podemos ver de solicitarle mas datos, el formulario se envia a la venta de windows, para comenzar el chat
function chat_email(){
?>
<div class="chat_userEmail">
	<h2>Preguntas?</h2>
    <h4>¡chatea con nosotros ahora!</h4>
	<form action="<?php echo chat_path; ?>/includes/windows.php" name="chat_access" id="chat_access" method="post">
    	<table align="center">
        	<tr>
            	<td>
                <label for="name">Tu nombre:</label>
                </td>
            </tr>
            <tr>
                <td>
                <input type="text" name="name" id="name" class="input-text" placeholder="Coloca aqui tu nombre" />
                </td>
            </tr>
            <tr>
                <td>
                <label for="email">Tu email:</label>
                </td>
            </tr>
            <tr>
                <td>
                <input type="text" name="email" id="email" class="input-text" placeholder="Necesitamos tu email" />
                </td>
            </tr>
            <tr>
                <td>
                <label for="first_question">Tu primer pregunta:</label>
                </td>
            </tr>
            <tr>
                <td>
                	<textarea name="first_question" id="first_question" placeholder="cuentanos que necesitas" class="textarea-msg"></textarea>
                </td>
            </tr>
            <tr>
                <td align="right">
                <input type="submit" name="sendEmail" id="sendEmail" value="Ingresar" class="button" />
                </td>
        	</tr>
        </table>
    </form>
    <div class="error-form"></div>
</div>
<?php
}



//Windows del chat, listado de mensajes filtrados por mail y formulario para chatear
function chat_windows(){
	
	$user_email = (isset($_POST['email']))?$_POST['email']:false;
	$is_support = (isset($_POST['is_support']))?$_POST['is_support']:0;
	
	$session_id = chat_set_access($user_email);
	$chat_options = chat_options();
	$chat_options = $chat_options[0];
 	if($user_email and $session_id): ?>
 		<?php $messages = chat_getMessages('sessions_id='.$session_id); ?>
        <?=($is_support==1)?'<h4>Viendo la session de:&nbsp;'.$user_email.'</h4>':'';?>
         <div id="chat_messages" class="box-list-messages">
            <ul id="list">
                <?php foreach($messages as $m):?>
                    <li id="m<?=$m->id;?>" times="<?=$m->times;?>"><span><?=($m->is_support==0)?$m->name:$chat_options->support_name;?></span>: <?=$m->msg;?></li>
                <?php $times=$m->times; endforeach; ?>
            </ul>
         </div>
         <form action="<?php echo chat_path; ?>/includes/addMessages.php" name="form_messages" id="form_messages" method="post">
         <input type="hidden" name="time_end" id="time_end" value="<?=$times;?>" />
            <input type="hidden" name="is_support" id="is_support" value="<?=$is_support;?>" />
            <input type="hidden" name="sessions_id" id="sessions_id" value="<?=$session_id;?>" />
            <input type="hidden" name="user_email" id="user_email" value="<?=($is_support==0)?$user_email:$chat_options->support_name;?>" />
            <input type="hidden" name="url_interval" id="url_interval" value="<?php echo chat_path; ?>/includes/get_messages.php" />
            <div class="box_messages">
            <textarea name="msg" id="msg" class="box-msg"></textarea>
            <input type="submit" name="sendMessage" id="sendMessage" value="Enviar" class="button send-msg" />
            </div>
         </form>
     <?php else: ?>
     <?php 
     chat_email();
 endif;
}

//Cuanod el usuario envia el mail, consultamos si existe en las sessiones, en caso contrario, creamos una session con ese email
function chat_set_access($user_email){
	global $wpdb;
	//Nombre del usuario que esta accediendo
	$name = (isset($_POST['name']))?$_POST['name']:'';
	//Su primera pregunta que inicializa el chat
	$question = (isset($_POST['first_question']))?$_POST['first_question']:'';
	//Fecha en la que ocurre todo
	$time = time();
	$fecha = date('Y-m-d h:i:s',$time);
	$data = array();
	//Si el email es falso, es que nunca se envio por post, por ende lo retiramos
	if($user_email){
		//Buscamos si existe una session con el email provisto, para continuar la charla en dodnde quedo.
		$get_sessions = chat_getSessions('email='.$user_email);
		//En caso de qeu exista la charla, la continuamos
		if($get_sessions){
			//Tomamos el ID de la session
			$session_id = $get_sessions[0]->id;
			//Si la session tiene algo o no.
			if($session_id){
				//Nos fijamos si el nombre ingreso por post y si esta vacio, para actualizarlo en la bd, o dejarlo como esta
				if(!empty($name)){
					$data['name'] = $name;
				}
				//Fecha y hora del acceso, lo agregamos a la session
				$data['fecha'] = $fecha;
				//cambios de ser necesario los valor por post que estan etnrando
				$_POST['is_support'] = 0;
				$_POST['sessions_id'] = $session_id;
				$_POST['msg'] = $question;
				//Actualizamos la session del usuario
				$wpdb->update('chat_sessions',$data,array('id'=>$session_id));
				//Si la pregunta no viene vacia, entonces la cargamos a los mensajes enviados del cliente
				if(!empty($question)){
					//Agregamos la pregunta, para esta funcion especifica necesitamos los post de arriva
					$first_question =  chat_addMessages('email='.$settings->email);
				}
			}//End session_id
		}else{
			//Si la session no existe, entonces la tenemos que crear
			$session_id = chat_addSessions('email='.$user_email.'&name='.$name.'&question='.$question);
		}
		return $session_id;
	}//En user_mail
return false;
}

//Funcion para la consulta de sisiones, filtrada o no filtrada
function chat_getSessions($options=array()){
	global $wpdb;
	$default['email'] = '';
	$default['sessions_id'] = '';
	$settings = getMerge($default, $options);
	
	$join = $filter = '';
	
	$colums = '
	s.id,
	s.user_email,
	s.name,
	s.fecha
	';
	//Consultamos las sessiones por medio del mail del usuario
	if(!empty($settings->email)){
		$filter.= 'AND s.user_email = \''.$settings->email.'\'';
	}
	//Consultamos las sessiones por medio del ID de la session
	if(!empty($settings->sessions_id)){
		$filter.= 'AND s.id = \''.$settings->sessions_id.'\'';
	}
	
	$query = 'SELECT '.$colums.' FROM chat_sessions s '.$join.' WHERE 1=1 '.$filter.' ';

	$sessions = $wpdb->get_results($query);
	
return $sessions;
}


//Funcion para agregar nuevas sesiones, devuelve el id del registro de la tabla sessiones.
function chat_addSessions($options=array()){
	global $wpdb;
	$default['email'] = '';
	$settings = getMerge($default, $options);
	//Fecha del inicio de session del cliente
	$time = time();
	$fecha = date('Y-m-d h:i:s',$time);
	//Si el email no esta vacio, entonces creamos la session
	if(!empty($settings->email)){
		//Insertamos la session en la base de datos, con emila, nombre y fecha.
		$wpdb->insert('chat_sessions',array('user_email'=>$settings->email,'name'=>$settings->name,'fecha'=>$fecha));
		//Tomamos el ID de ssion que fue brindado en el insert a la tabla sessiones
		$session_id = mysql_insert_id();
		//Si es verdadero entramos
		if($session_id){
			//Estos datos los necesitamos para el insert en la base de datos
			$_POST['is_support'] = 0;
			$_POST['sessions_id'] = $session_id;
			$_POST['msg'] = $settings->question;
			//Agregamos el mensaje
			$first_question =  chat_addMessages('email='.$settings->email);
		}//End session_id
		//Retornamos el ID de la session
		return $session_id;
	}
//Si todo sale mal, devolvemos false
return false;
}


//Opciones generales del chat
function chat_options($options=array()){
	global $wpdb;
	$default['support_id'] = '1';
	$settings = getMerge($default, $options);
	
	$join = $filter = '';
	
	$colums = '
	o.id,
	o.is_online,
	o.support_name,
	o.support_email
	';
	//Filtramos por el id support
	$filter.= ' AND o.id = '.$settings->support_id;
	
	$query = 'SELECT '.$colums.' FROM chat_options o '.$join.' WHERE 1=1 '.$filter.' ';

	$options = $wpdb->get_results($query);
	
return $options;
}





//Devuelve los mensajes de el chat
function chat_getMessages($options=array()){
	global $wpdb;
	$default['sessions_id'] = '';
	$default['is_support'] = '5';
	$default['times'] = '';
	$settings = getMerge($default, $options);
	
	$join = $filter = '';
	
	$colums = '
	m.id,
	m.s_from,
	m.msg,
	m.times,
	m.is_support,
	s.user_email,
	s.name';
	
	//Filtramos por el ID de session
	$filter.= ' AND m.s_from = '.$settings->sessions_id;
	
	//tremos solos los mensajes del soporte y filtramos por el fecha de envio
	if($settings->is_support==1){
		$filter.= ' AND m.s_from = '.$settings->sessions_id.' AND m.is_support = 1 AND m.times > \''.$settings->times.'\'';
	}
	
	//Traemos solo los mensajes del cliente y filtramos por fecha de envio
	if($settings->is_support==0){
		$filter.= ' AND m.s_from = '.$settings->sessions_id.' AND m.is_support = 0 AND m.times > \''.$settings->times.'\'';
	}
	//Consultamos la session para traer los datos principales del cliente
	$join.= ' LEFT JOIN chat_sessions s ON s.id = m.s_from';
	//Query
	$query = 'SELECT '.$colums.' FROM chat_messages m '.$join.' WHERE 1=1 '.$filter.' ORDER BY m.times asc ';

	$messages = $wpdb->get_results($query);
	
return $messages;

}

//Agrega un nuevo mensaje y devuelve solo ese mensaje
function chat_addMessages($options=array()){
	global $wpdb;
	//Opciones generales del chat
	$chat_options = chat_options();
	$chat_options = $chat_options[0];
	
	$default['email'] = '';
	$settings = getMerge($default, $options);
	//Fecha
	$time = time();
	$time = date('Y-m-d h:i:s',$time);
	
	//Verificamos si es cliente o soporte
	$is_support = (isset($_POST['is_support']) and $_POST['is_support'])?$_POST['is_support']:0;
	
	//si el mensaje no viene vacio, cargamos el mensaje en la base de datos
	if(!empty($_POST['msg'])){
		//Creamos el array con los datos
		$data = array(
			's_from' => $_POST['sessions_id'],
			'msg'=>$_POST['msg'],
			'times'=>$time,
			'is_support'=>$is_support
		);
		//Realizamos el insert
		$retorno = $wpdb->insert('chat_messages',$data);
		$id_message = mysql_insert_id();
		//Treamos la session del usuario
		$user_session = chat_getSessions('sessions_id='.$_POST['sessions_id']);
		//Nos fijamos cual es el autor del mensaje y de acuerdo a eso, mostramos cual es el autor
		$author = ($is_support==0)?$user_session[0]->name:$chat_options->support_name;
		//Si el mensaje se cargo en la base de datos, mostramos el resultado rapidamente sin consultas
		if($retorno){
			return '<li id="m'.$id_message.'"  times="'.$time.'"><span>'.$author.'</span>: '.$_POST['msg'].'</li>';
		}else{
			return '<li id="mError"  times="'.$time.'"><span>Error:</span>: Su mensaje no fue enviado</li>';
		}
	}
return '<li id="m'.$id_message.'"  times="'.$time.'"><span>Error:</span>: Su mensaje no fue enviado</li>';
}


//Funcion de listado de sessiones del admin
function chat_admin(){
	global $wpdb;
	
	//Eliminar session del cliente
	if(isset($_GET['eliminar'])){
		$sessions_id = $_GET['eliminar'];
		$delete = $wpdb->get_results('DELETE FROM chat_messages WHERE s_from = '.$sessions_id);
		$delete = $wpdb->get_results('DELETE FROM chat_sessions WHERE id = '.$sessions_id);
	}
	//Vaciar mensajes del usuario
	if(isset($_GET['vaciar'])){
		$sessions_id = $_GET['vaciar'];
		$delete = $wpdb->get_results('DELETE FROM chat_messages WHERE s_from = '.$sessions_id);
	}
	
	//Guardamos las nuevas opciones
	if(isset($_GET['options'])){
		$is_online = $_POST['is_online'];
		$support_name = $_POST['support_name'];
		$wpdb->update('chat_options',array('is_online'=>$is_online,'support_name'=>$support_name),array('id'=>1));
	}
	//Treamos de la base todas las sessiones existentes
	$sessiones = chat_getSessions();
	
	//Opciones generales del chat
	$chat_options = chat_options();
	$chat_options = $chat_options[0];
	?>
    <div class="wrap">
    <div id="ajax-response" url="<?=chat_path; ?>"></div>
    	<h2>Chat live</h2>
        <div class="chat_columSessions">
        <h3>Datos del Soporte</h3>
        <form action="admin.php?page=chat-live&options=1" method="post">
        <table>
        	<tbody>
            	<tr>
                	<td>Estas ahora online? <input type="checkbox" name="is_online" id="is_online" value="1" <?=($chat_options->is_online==1)?' checked="checked"':'';?>></td>
                </tr>
                <tr>
                	<td>Nombre del Soporte <input type="text" name="support_name" id="support_name" value="<?=$chat_options->support_name;?>" /></td>
                </tr>
                <tr>
                	<td><input type="submit" name="saveOptions" id="saveOptions" value="Guardar" /></td>
                </tr>
            </tbody>
        </table>
        </form>
        <div class="clear"></div>
        <h3>Sesiones abiertas</h3>
        <div class="clear"></div>
        <table class="widefat">
        	<thead>
                <tr>
                    <th>Sesión</th>
                    <th>Nombre</th>
                    <th>Email</th>
                    <th>...</th>
                </tr>
            </thead>
            <tbody id="chat_Sesssiones">
            <?php if($sessiones):?>
            <?php $i=0; foreach($sessiones as $s):?>
            	<tr sessions="<?=$s->id;?>" user_email="<?=$s->user_email;?>" chat="<?php echo chat_path; ?>/includes/windows.php">
                	<td><?=$s->id;?></td>
                    <td><?=$s->name;?></td>
                    <td><?=$s->user_email;?></td>
                    <td><a href="admin.php?page=chat-live&vaciar=<?=$s->id;?>">Vaciar</a> / <a href="admin.php?page=chat-live&eliminar=<?=$s->id;?>">Eliminar</a></td>
                </tr>
            <?php $i++; endforeach; ?>
            <?php else: ?>
            	<tr>
                	<td colspan="4"> No hay sesiones abiertas</td>
                </tr>
            <?php endif; ?>
            </tbody>
            <tfoot>
                <tr>
                    <th>Sesión</th>
                    <th>Nombre</th>
                    <th>Email</th>
                    <th>...</th>
                </tr>
            </tfoot>
        </table>
        <input type="hidden" name="count_sessions" id="count_sessions" value="<?=$i;?>" />
        </div>
    </div>
    <div id="chat_messagesAdmin" class="chat_columMessages">
    </div>
    <div class="clear"></div>
    <?php
}

//Chequear si hay nuevos mensajes, esta funcion se ejecuta cada 5 segundos, mediante javascript
function chat_new_messages(){
	//Tomamos los datos que vienen por post (Estos datos son enviados por post mediante jquery).
	$sessions_id = $_POST['sessions_id'];
	$times = $_POST['times'];
	$is_support = $_POST['is_support'];
	//Datos de soporte principales
	$chat_options = chat_options();
	$chat_options = $chat_options[0];
	//Treamos la session del usuario
	$user_session = chat_getSessions('sessions_id='.$_POST['sessions_id']);
	//traer mensajes del cliente, solo mayores que el tiempo del ultimo mensaje
	$messages = chat_getMessages('sessions_id='.$sessions_id.'&is_support='.$is_support.'&times='.$times);
	//Mostramos todos los mensajes nuevos existentes en la base de datos pero solo del cliente, y en cuyo caso solo del soporte.
	foreach($messages as $m):?>
        <li id="m<?=$m->id;?>" times="<?=$m->times;?>"><span><?=($m->is_support==0)?$user_session[0]->name:$chat_options->support_name;?>: </span> <?=$m->msg;?></li>
    <?php endforeach;
}


//Merge settings
function getMerge($default, $options, $array=FALSE) {
        if (is_array($options)) {
            $settings = array_merge($default, $options);
        } else {
            parse_str($options, $output);
            $settings = array_merge($default, $output);
        }

        return ($array) ? $settings : (Object) $settings;
    }
	
	
/****************************************************************
INSTALLATION PLUGINS, INSERT TABLES INTO DB
******************************************************************/
function chat_install_tables() {
	global $wpdb;
    $sql = file_get_contents(chat_lib.'/chatlive_tables.sql'); // Leo el archivo
    // Lo siguiente hace gran parte de la magia, nos devuelve todos los tokens no vacíos del archivo
    $tokens = preg_split("/(--.*\s+|\s+|\/\*.*\*\/)/", $sql, null, PREG_SPLIT_NO_EMPTY);
    $length = count($tokens);
    
    $query = '';
    $inSentence = false;
    $curDelimiter = ";";
    // Comienzo a recorrer el string
    for($i = 0; $i < $length; $i++) {
		 $lower = strtolower($tokens[$i]);
		 $isStarter = in_array($lower, array( // Chequeo si el token actual es el comienzo de una consulta
			 'select', 'update', 'delete', 'insert',
			 'delimiter', 'create', 'alter', 'drop', 
			 'call', 'set', 'use'
		 ));
	
		 if($inSentence) { // Si estoy parseando una sentencia me fijo si lo que viene es un delimitador para terminar la consulta
			 if($tokens[$i] == $curDelimiter || substr(trim($tokens[$i]), -1*(strlen($curDelimiter))) == $curDelimiter) { 
				  // Si terminamos el parseo ejecuto la consulta
				  $query .= str_replace($curDelimiter, '', $tokens[$i]); // Elimino el delimitador
				  $wpdb->query($query);
				  $query = ""; // Preparo la consulta para continuar con la siguiente sentencia
				  $tokens[$i] = '';
				  $inSentence = false;
			 }//End tokends
		 }else if($isStarter) { // Si hay que comenzar una consulta, verifico qué tipo de consulta es
			 // Si es delimitador, cambio el delimitador usado. No marco comienzo de secuencia porque el delimitador se encarga de eso en la próxima iteración
			 if($lower == 'delimiter' && isset($tokens[$i+1]))  
				  $curDelimiter = $tokens[$i+1]; 
					 else
				  $inSentence = true; // Si no, comienzo una consulta 
			 $query = "";
		 }//End is starter
		 $query .= "{$tokens[$i]} "; // Voy acumulando los tokens en el string que contiene la consulta
    }//End for
}
register_activation_hook(__FILE__,'chat_install_tables');
?>